;
;	Sample player
;
; 	Monophonic, II osc. just to test wav player idea ++

; This sample player proto takes samples of 
; any length, plays them from the start at a 
; keypress, and stops at key release.

DISA    = 0x2600        ; IO addresses
DISD    = 0x2400
KEYA    = 0x2a00
KEYD    = 0x2800
DAC     = 0x2c00
	.globl  DISA,DISD,KEYA,KEYD,DAC

	.module SAMP
	.area	samp	(ABS,OVR)	; now takes zero page and further
	.globl	.begin

.sbase	= 0x1000	; ptr to sample base adress
.sptr	= 0x1e80	; variable: sample ptr
.send	= 0x1e82	; var: sample end ptr
.key	= 0x1e84	; var: key pressed
.pinc	= 0x1e86	; var: phase increment
.pptrl	= 0x1e88	; var: phase ptr low word
.pptrh	= 0x1e8A	; var: phase ptr high word
.ppmax	= 0x1e8C	; var: phase ptr max phase (msw)
.seqstate	= 0x1e90
.seqstep	= 0x1e92
.seqcount	= 0x1e94
.seqlist	= 0x1e00

.seqsoff	= 0
.seqsprog	= 1
.seqsrun	= 2

	.org	0x000
.reset: ld      sp,#0x1ffe
	im      0
	di
	jp      .begin
;	jp	.menus

       .=.reset+#0x0010
.begin:	ld	hl,#.sbase	; pointer to samples
        ld	a,#0x10		; lowest row of keys
	ld	(KEYA),a
	ld	de,#0		; phase increment register, lsw
	ld	bc,#0x6000
	exx
	ld	bc,#0x6000
	exx
	ld	a,#.seqsoff
	ld	(.seqstate),a
.keyl:	call	.getkey
	cp	#255
	jp	z,.keyl
	cp	#40
	jp	m,.command	; computer keyboard
	sub	#40
	add	#39-2*12+1
	
	push	hl
	ld	h,a
	ld	a,(#.seqstate)
	cp	#.seqsprog
	ld	a,h
	pop	hl
	call	z,.doseqp

.saml1:	ld	hl,#5000
	call	.play
;	ld	a,#0b00011111	; select 40 keys ( 5 rows are active)
	ld	a,#0b11110000
	ld	(KEYA),a
.snrp2:	ld	a,(KEYD)
	and	#0xff
	ld	a,(.key);
	jp	nz,.saml1
	call	.dly1		; key release debounce
	jp	.keyl

; play a note with duration given by hl (in samples)
; a is desired note number (0 is lowest in 40 long table)

.play:	ld	(#.seqcount),hl
.kmain:	ld	(#.key),a
	ld	(DISD),a
;	add	#39-3*12+1
	
	ld	hl,#.note40	; look up phase increment for keycode
	add	a
	add	l		; ( watch out for pages boundaries)
	ld	l,a
	ld	c,(hl)		; increment in bc
	inc	l
	ld	b,(hl)
	ld	(#.pinc),bc	; store for OSC I .

	ld	hl,#.sbase	; reset sample base completely
	ld	de,#0
	exx
	ld	bc,(#.pinc)	; read increment for OSC II
	inc	b		; crude DETUNE
;	inc	b
;	inc	b
	ld	hl,#.sbase	; reset sample base completely
	ld	de,#0
	exx


.saml:	ld	a,(hl)		; read sample
	ld	(DAC),a		; output
	ex	de,hl
	add	hl,bc		; do increment
	ex	de,hl
	ld	a,h
;	ld	(DISA),a
;	ld	(DISD),a
;	ld	(DISA),a
;	ld	(DISA),a
	push	bc
	ld	bc,#0
	adc	hl,bc		; phase increment carry
	pop	bc
	ld	a,h		; push back one page when at sample end
	add	#0x100-#0x1d
	ld	a,h
	sbc	#0
	ld	h,a
	

	exx	;;;;;;;;;;;;;;;;; same for alternate reg set: voice II
	ld	a,(hl)		; read sample
;	ld	(DAC),a		; output
	ex	de,hl
	add	hl,bc		; do increment
	ld	(DAC),a		; output (displaced for symmetry)
	ex	de,hl
	ld	a,h
	push	bc
	ld	bc,#0
	adc	hl,bc		; phase increment carry
	pop	bc
	ld	a,h		; push back one page when at sample end
	add	#0x100-#0x1d
	ld	a,h
	sbc	#0
	ld	h,a


.snrp1:	exx	;;;;;;;;;;;;;;;;;
	push	hl
	ld	hl,(.seqcount)
	dec	hl
	ld	(.seqcount),hl
	ld	a,h
	or	l
	pop	hl
	jp	nz,.saml
	ret
	


.keyrl:	ld	a,(KEYD)
	and	a
	jp	nz,.keyrl
	jp	.keyl


.command:
	cp	#32
	jp	nz,.com2
	ld	a,#.seqsprog
	ld	(#.seqstate),a
	jp	.comr
.com2:	cp	#33
	jp	nz,.com3
	ld	a,#.seqsrun
	ld	(#.seqstate),a
	call	.doseqpl
	jp	.comr
.com3:	cp	#34
	jp	nz,.com4
	ld	a,#0
	ld	(#.seqstep),a
	ld	(DISA),a
	ld	(DISA),a
	ld	(DISA),a
	ld	(DISA),a
	jp	.comr

.com4:
.comr:	ld	(DISD),a
	jp	.keyl

.doseqpl:
	push	hl
	push	af
	xor	a
	dec	a
.seqpl1:
	ld	hl,#.seqlist
	ld	a,(#.seqstep)
	add	a,l
	ld	l,a
	ld	a,(#.seqstep)
	sla	a
	sla	a
	sla	a
	sla	a
	ld	(DISA),a
	ld	(DISA),a
	ld	(DISA),a
	ld	(DISA),a
	ld	a,(hl)
	ld	(DISD),a


	ld	a,#4
	ld	(.keyc),a
.gkz0:	call	.getkey
	cp 	#255
	jp	nz,.gkz1	; found key
        ld	a,(.keyc)
	cp	#0
	jp	nz,.gkz0	; check all keys
	ld	a,#11
.gkz1:	
	add	(hl)
	sub	#11
	ld	hl,#3000
	call	.play
	ld	a,(#.key)
;	sub	#12
;	ld	hl,#10000
;	call	.play

	ld	a,(#.seqstep)
	inc	a
	and	#0x0f
	ld	(#.seqstep),a
	ld	a,#0b00010000
	ld	(KEYA),a
	nop
	ld	a,(KEYD)
	and	#0b11111000
	jp	z,.seqpl1
	pop	af
	pop	hl
	ret
	

.doseqp:
	push	hl
	push	af
	ld	hl,#.seqlist
	ld	a,(#.seqstep)
	add	a,l
	ld	l,a
	ld	a,(#.seqstep)
	inc	a
	and	#0x0f
	ld	(#.seqstep),a
	ld	a,(#.seqstep)
	sla	a
	sla	a
	sla	a
	sla	a
	ld	(DISA),a
	ld	(DISA),a
	ld	(DISA),a
	ld	(DISA),a
	pop	af
	ld	(hl),a
	ld	(DISD),a
	pop	hl
	ret


; delay routine
.dly1:	push	hl
	ld	hl,#3000
	dec	hl
	jp	nz,.dly1
	pop	hl
	ret
;;;;;	jp	.keyl


;
;       Keyboard routines
;

; vars: .keyc .keyl: column, last key

;	.module KEYBOARD
;	.area   keyboard        (ABS,OVR)
;	.globl  .typec, .keybd
;	.org    0x0200          ; third page in mem, 
				; for debugging ease

.keyc	= 0x1e30		; current column # of keyboard decoder


.getkey:
	push	hl
	push	de
	ld      a,(KEYD)
	ld      l,a             ; key pattern
	ld      a,(#.keyc)
	ld      e,a             ; key column #
	inc     a
	and     #7
	ld      (#.keyc),a      ; new col# in store
	ld      h,a
	ld      a,#1
	inc     h
.typ2:  dec     h		; single bit scan pattern for key row
	jp      z,.typ1
	add     a,a
	jp      .typ2
.typ1:  ld      (KEYA),a        ; set new scan address
;                               ; l=read key scan
	ld      h,#1            ; shifting 1
	ld      d,#0            ; counter
.typ5:  ld      a,l
	and     h
	jp      nz,.typ4
	inc     d
	sla     h
	jp      nz,.typ5        ; nothing pressed
	ld      a,#7
	cp      e
	ld	a,#0xff		; indicate no key found
	jp      nz,.typ7
	ld      a,#0xff         ; end of scan: no key
	jp      .typ7           ; then ff
	
.typ4:  ld      a,e             ; keycode = 8*colum+row of first hit
	add     a
	add     a
	add     a
	add     d
;	neg
;	add	#39
;	sub	#40
.typ7:	pop	de
	pop	hl
	ret

.waitup:
	push	af
	ld	a,#0xff
	ld	(KEYA),a
	call	.dly1
.waitup1:
	ld	a,(KEYD)
	and	#0xff
	jp	nz,.waitup1
	call	.dly1
	pop	af
	ret


;
;	table of 40 phase increment factors, for half 
;	note intervals, ending ad 2^16-1, accuracy -1 bits (of 16)
;

	.org	0x0300		; put in new page
.note40bak:
	.dw	0x1AE8	;  0 
	.dw	0x1C82	;  1 
	.dw	0x1E34	;  2 
	.dw	0x2000	;  3 
	.dw	0x21E7	;  4 
	.dw	0x23EB	;  5 
	.dw	0x260E	;  6 
	.dw	0x2851	;  7 
	.dw	0x2AB7	;  8 
	.dw	0x2D41	;  9 
	.dw	0x2FF2	;  10 
	.dw	0x32CC	;  11 
	.dw	0x35D1	;  12 
	.dw	0x3904	;  13 
	.dw	0x3C68	;  14 
	.dw	0x4000	;  15 
	.dw	0x43CE	;  16 
	.dw	0x47D6	;  17 
	.dw	0x4C1B	;  18 
	.dw	0x50A2	;  19 
	.dw	0x556D	;  20 
	.dw	0x5A82	;  21 
	.dw	0x5FE4	;  22 
	.dw	0x6597	;  23 
	.dw	0x6BA2	;  24 
	.dw	0x7208	;  25 
	.dw	0x78D0	;  26 
	.dw	0x7FFF	;  27 
	.dw	0x879B	;  28 
	.dw	0x8FAC	;  29 
	.dw	0x9837	;  30 
	.dw	0xA144	;  31 
	.dw	0xAADB	;  32 
	.dw	0xB504	;  33 
	.dw	0xBFC7	;  34 
	.dw	0xCB2E	;  35 
	.dw	0xD743	;  36 
	.dw	0xE410	;  37 
	.dw	0xF1A0	;  38 
	.dw	0xFFFE	;  39 
.note40:
	.include "note40g.asm"
