;
;	Sample player
;
; 	Monophonic, II osc. just to test wav player idea ++

; This sample player proto takes samples of 
; any length, plays them from the start at a 
; keypress, and stops at key release.

DISA    = 0x2600        ; IO addresses
DISD    = 0x2400
KEYA    = 0x2a00
KEYD    = 0x2800
DAC     = 0x2c00
	.globl  DISA,DISD,KEYA,KEYD,DAC

	.module SAMP
	.area	samp	(ABS,OVR)	; now takes zero page and further
	.globl	.begin

.sbase	= 0x1000	; ptr to sample base adress
.gdet	= 0x1e00	; ptr to additional global detune value

.sptr	= 0x1e80	; variable: sample ptr
.send	= 0x1e82	; var: sample end ptr
.key	= 0x1e84	; var: key pressed
.pinc	= 0x1e86	; var: phase increment
.pinc1	= 0x1e88
.pinc2	= 0x1e90
.pptrl	= 0x1e98	; var: phase ptr low word
.pptrh	= 0x1e9A	; var: phase ptr high word
.ppmax	= 0x1e9C	; var: phase ptr max phase (msw)
; .notes1	= 0x0800
; .notes2	= 0x0900
.seqstate	= 0x1ea0
.seqstep	= 0x1ea2
.seqcount	= 0x1ea4
.seqlist	= 0x1eb0

.seqsoff	= 0
.seqsprog	= 1
.seqsrun	= 2

	.org	0x000
.reset: ld      sp,#0x1ffe
	im      0
	di
	jp      .begin
;	jp	.menus

       .=.reset+#0x0010
.begin:	ld	hl,#.sbase	; pointer to samples
        ld	a,#0x10		; lowest row of keys
	ld	(KEYA),a
	ld	de,#0		; phase increment register, lsw
	ld	bc,#0x6000
	exx
	ld	bc,#0x6000
	exx
	ld	a,#.seqsoff
	ld	(.seqstate),a
	ld	a,#0
	ld	(#.gdet),a
.keyl:	call	.getkey
	cp	#255
;;;;	jp	z,.dly1
	jp	z,.keyl
	cp	#40
	jp	m,.command	; computer keyboard
	sub	#40
	add	#39-2*12+1
.kmain:	ld	(#.key),a
;	ld	(DISD),a
;	add	#39-3*12+1
	
	ld	hl,#.notes1	; look up phase increment for keycode
	add	a
	add	l		; ( watch out for pages boundaries)
	ld	l,a
	ld	c,(hl)		; increment in bc
	inc	l
	ld	b,(hl)
	ld	(#.pinc1),bc	; store for OSC I .

	ld	hl,#.sbase	; reset sample base completely
	ld	de,#0
	exx			; " same for OSC II
	ld	a,(#.key)
	ld	hl,#.notes2	; look up phase increment for keycode
	add	a
	add	l		; ( watch out for pages boundaries)
	ld	l,a
	ld	c,(hl)		; increment in bc
	inc	l
	ld	b,(hl)
	ld	(#.pinc2),bc	; store for OSC II .

	ld	c,#0		; add global detune for osc II
	ld	a,(#.gdet)
	ld	b,a
	ld	(DISD),a
	ld	hl,(#.pinc2)
	add	hl,bc
	ld	(#.pinc2),hl
	ld	bc,(#.pinc2)

;	inc	b		; crude DETUNE
;	inc	b
;	inc	b
;	inc	b
	ld	hl,#.sbase	; reset sample base completely
	ld	de,#0
	exx

;	ld	a,#0b00011111	; select 40 keys ( 5 rows are active)
	ld	a,#0b11110000
	ld	(KEYA),a

.saml:	ld	a,(hl)		; read sample
	ld	(DAC),a		; output
	ex	de,hl
	add	hl,bc		; do increment
	ex	de,hl
	ld	a,h
;	ld	(DISA),a
;	ld	(DISD),a
;	ld	(DISA),a
;	ld	(DISA),a
	push	bc
	ld	bc,#0
	adc	hl,bc		; phase increment carry
	pop	bc
	ld	a,h		; push back one page when at sample end
	add	#0x100-#0x1d
	ld	a,h
	sbc	#0
	ld	h,a
	

	exx	;;;;;;;;;;;;;;;;; same for alternate reg set: voice II
	ld	a,(hl)		; read sample
;	ld	(DAC),a		; output
	ex	de,hl
	add	hl,bc		; do increment
	ld	(DAC),a		; output (displaced for symmetry)
	ex	de,hl
	ld	a,h
	push	bc
	ld	bc,#0
	adc	hl,bc		; phase increment carry
	pop	bc
	ld	a,h		; push back one page when at sample end
	add	#0x100-#0x1d
	ld	a,h
	sbc	#0
	ld	h,a


.snrp1:	exx	;;;;;;;;;;;;;;;;;

.snrp2:	ld	a,(KEYD)
	and	#0xff
	jp	nz,.saml
	call	.dly1		; key release debounce
	jp	.keyl

.command:
	cp	#32
	jp	z,.seqpr
	cp	#33
	jp	z,.seqpl
	jp	.kmain

.seqpr:
	push	af
	ld	a,#0
	ld	(.seqstep),a
	pop	af
.seqprl:	
	call	.getkey
	call	.dly1
	cp	#0xff
	jp	z,.seqprl
	call	.waitup
	cp	#32
	jp	z,.seqpr
	cp	#33
	jp	z,.seqpl
	cp	#39
	jp	z,.kmain
	push	hl
	push	af
	ld	hl,#.seqstep
	ld	a,(hl)
	inc	a
	and	#0x0f
	ld	(hl),a
	ld	hl,#.seqlist
	add	a,l
	ld	l,a
	pop	af
	ld	(DISD),a
	ld	(hl),a
	ld	a,l
	sla	a
	sla	a
	sla	a
	sla	a
	ld	(DISA),a
	ld	(DISA),a
	ld	(DISA),a
	pop	hl
	call	.waitup
	jp	.seqprl

.seqpl:	call	.getkey
	cp	#0xff
	jp	z,.seqpl
	cp	#32
	jp	z,.seqpr
	cp	#33
	jp	z,.seqpl
	cp	#39
	jp	.kmain
	
	call	.waitup
	jp	.seqpl


; delay routine
.dly1:	push	hl
	ld	hl,#3000
	dec	hl
	jp	nz,.dly1
	pop	hl
	ret
;;;;;	jp	.keyl


;
;       Keyboard routines
;

; vars: .keyc .keyl: column, last key

;	.module KEYBOARD
;	.area   keyboard        (ABS,OVR)
;	.globl  .typec, .keybd
;	.org    0x0200          ; third page in mem, 
				; for debugging ease

.keyc	= 0x1ec0		; current column # of keyboard decoder


.getkey:
	push	hl
	push	de
	ld      a,(KEYD)
	ld      l,a             ; key pattern
	ld      a,(#.keyc)
	ld      e,a             ; key column #
	inc     a
	and     #7
	ld      (#.keyc),a      ; new col# in store
	ld      h,a
	ld      a,#1
	inc     h
.typ2:  dec     h		; single bit scan pattern for key row
	jp      z,.typ1
	add     a,a
	jp      .typ2
.typ1:  ld      (KEYA),a        ; set new scan address
;                               ; l=read key scan
	ld      h,#1            ; shifting 1
	ld      d,#0            ; counter
.typ5:  ld      a,l
	and     h
	jp      nz,.typ4
	inc     d
	sla     h
	jp      nz,.typ5        ; nothing pressed
	ld      a,#7
	cp      e
	ld	a,#0xff		; indicate no key found
	jp      nz,.typ7
	ld      a,#0xff         ; end of scan: no key
	jp      .typ7           ; then ff
	
.typ4:  ld      a,e             ; keycode = 8*colum+row of first hit
	add     a
	add     a
	add     a
	add     d
;	neg
;	add	#39
;	sub	#40
.typ7:	pop	de
	pop	hl
	ret

.waitup:
	push	af
	ld	a,#0xff
	ld	(KEYA),a
	call	.dly1
.waitup1:
	ld	a,(KEYD)
	and	#0xff
	jp	nz,.waitup1
	call	.dly1
	pop	af
	ret


;
;	table of 40 phase increment factors, for half 
;	note intervals, ending ad 2^16-1, accuracy -1 bits (of 16)
;

	.org	0x0300		; put in new page
	.include "note40g.asm"
